
_set_up:

;Voltmeter.c,12 :: 		void set_up() {   //configuration for Pic16f887
;Voltmeter.c,14 :: 		ANSEL = 0x04;      // Pin RA2 sets as analog input.
	MOVLW      4
	MOVWF      ANSEL+0
;Voltmeter.c,15 :: 		TRISA = 0x04;
	MOVLW      4
	MOVWF      TRISA+0
;Voltmeter.c,16 :: 		ADCON1 = 0x82;    // the Vref is Vcc.
	MOVLW      130
	MOVWF      ADCON1+0
;Voltmeter.c,17 :: 		ANSELH = 0;      // the rest of the pins set as digital Inputs or outputs.
	CLRF       ANSELH+0
;Voltmeter.c,18 :: 		C1ON_bit = 0;    // analog comparators off.
	BCF        C1ON_bit+0, BitPos(C1ON_bit+0)
;Voltmeter.c,19 :: 		C2ON_bit = 0;
	BCF        C2ON_bit+0, BitPos(C2ON_bit+0)
;Voltmeter.c,20 :: 		CCP1CON = 0;   //PWM1 y PWM2 off.
	CLRF       CCP1CON+0
;Voltmeter.c,21 :: 		CCP2CON = 0;
	CLRF       CCP2CON+0
;Voltmeter.c,22 :: 		TRISB = 0;
	CLRF       TRISB+0
;Voltmeter.c,23 :: 		TRISD = 0;    // Clear  PORTB and PORTD.
	CLRF       TRISD+0
;Voltmeter.c,24 :: 		PORTB = 0;
	CLRF       PORTB+0
;Voltmeter.c,25 :: 		PORTD = 0;
	CLRF       PORTD+0
;Voltmeter.c,27 :: 		}
L_end_set_up:
	RETURN
; end of _set_up

_printf:

;Voltmeter.c,28 :: 		void  printf() {
;Voltmeter.c,31 :: 		short int i=0;
	CLRF       printf_i_L0+0
;Voltmeter.c,33 :: 		for (i=0; i<=86; i++) { // routine to stabilize the changes of voltage
	CLRF       printf_i_L0+0
L_printf0:
	MOVLW      128
	XORLW      86
	MOVWF      R0+0
	MOVLW      128
	XORWF      printf_i_L0+0, 0
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 0
	GOTO       L_printf1
;Voltmeter.c,34 :: 		ch1 = tlong / 1000;
	MOVLW      232
	MOVWF      R4+0
	MOVLW      3
	MOVWF      R4+1
	CLRF       R4+2
	CLRF       R4+3
	MOVF       _tlong+0, 0
	MOVWF      R0+0
	MOVF       _tlong+1, 0
	MOVWF      R0+1
	MOVF       _tlong+2, 0
	MOVWF      R0+2
	MOVF       _tlong+3, 0
	MOVWF      R0+3
	CALL       _Div_32x32_S+0
;Voltmeter.c,35 :: 		PORTD = 1;         // on  thousands and ch1, off ch2, ch3 and ch4
	MOVLW      1
	MOVWF      PORTD+0
;Voltmeter.c,36 :: 		PORTB = display[ch1] ;
	MOVF       R0+0, 0
	ADDLW      _display+0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      PORTB+0
;Voltmeter.c,37 :: 		delay_ms(2);
	MOVLW      3
	MOVWF      R12+0
	MOVLW      151
	MOVWF      R13+0
L_printf3:
	DECFSZ     R13+0, 1
	GOTO       L_printf3
	DECFSZ     R12+0, 1
	GOTO       L_printf3
	NOP
	NOP
;Voltmeter.c,38 :: 		ch2 = (tlong/100) % 10 ;
	MOVLW      100
	MOVWF      R4+0
	CLRF       R4+1
	CLRF       R4+2
	CLRF       R4+3
	MOVF       _tlong+0, 0
	MOVWF      R0+0
	MOVF       _tlong+1, 0
	MOVWF      R0+1
	MOVF       _tlong+2, 0
	MOVWF      R0+2
	MOVF       _tlong+3, 0
	MOVWF      R0+3
	CALL       _Div_32x32_S+0
	MOVLW      10
	MOVWF      R4+0
	CLRF       R4+1
	CLRF       R4+2
	CLRF       R4+3
	CALL       _Div_32x32_S+0
	MOVF       R8+0, 0
	MOVWF      R0+0
	MOVF       R8+1, 0
	MOVWF      R0+1
	MOVF       R8+2, 0
	MOVWF      R0+2
	MOVF       R8+3, 0
	MOVWF      R0+3
;Voltmeter.c,39 :: 		PORTD = 2;            // on hundreds and ch2, off  ch1, ch3 and ch4.
	MOVLW      2
	MOVWF      PORTD+0
;Voltmeter.c,40 :: 		PORTB = display1[ch2] ;
	MOVF       R0+0, 0
	ADDLW      _display1+0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      PORTB+0
;Voltmeter.c,41 :: 		delay_ms(2);
	MOVLW      3
	MOVWF      R12+0
	MOVLW      151
	MOVWF      R13+0
L_printf4:
	DECFSZ     R13+0, 1
	GOTO       L_printf4
	DECFSZ     R12+0, 1
	GOTO       L_printf4
	NOP
	NOP
;Voltmeter.c,42 :: 		ch3 = (tlong/10) % 10;
	MOVLW      10
	MOVWF      R4+0
	CLRF       R4+1
	CLRF       R4+2
	CLRF       R4+3
	MOVF       _tlong+0, 0
	MOVWF      R0+0
	MOVF       _tlong+1, 0
	MOVWF      R0+1
	MOVF       _tlong+2, 0
	MOVWF      R0+2
	MOVF       _tlong+3, 0
	MOVWF      R0+3
	CALL       _Div_32x32_S+0
	MOVLW      10
	MOVWF      R4+0
	CLRF       R4+1
	CLRF       R4+2
	CLRF       R4+3
	CALL       _Div_32x32_S+0
	MOVF       R8+0, 0
	MOVWF      R0+0
	MOVF       R8+1, 0
	MOVWF      R0+1
	MOVF       R8+2, 0
	MOVWF      R0+2
	MOVF       R8+3, 0
	MOVWF      R0+3
;Voltmeter.c,43 :: 		PORTD = 4;             // on tens and ch3, off ch1, ch2 and ch4.
	MOVLW      4
	MOVWF      PORTD+0
;Voltmeter.c,44 :: 		PORTB = display[ch3] ;
	MOVF       R0+0, 0
	ADDLW      _display+0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      PORTB+0
;Voltmeter.c,45 :: 		delay_ms(2);
	MOVLW      3
	MOVWF      R12+0
	MOVLW      151
	MOVWF      R13+0
L_printf5:
	DECFSZ     R13+0, 1
	GOTO       L_printf5
	DECFSZ     R12+0, 1
	GOTO       L_printf5
	NOP
	NOP
;Voltmeter.c,46 :: 		ch4 = tlong % 10;
	MOVLW      10
	MOVWF      R4+0
	CLRF       R4+1
	CLRF       R4+2
	CLRF       R4+3
	MOVF       _tlong+0, 0
	MOVWF      R0+0
	MOVF       _tlong+1, 0
	MOVWF      R0+1
	MOVF       _tlong+2, 0
	MOVWF      R0+2
	MOVF       _tlong+3, 0
	MOVWF      R0+3
	CALL       _Div_32x32_S+0
	MOVF       R8+0, 0
	MOVWF      R0+0
	MOVF       R8+1, 0
	MOVWF      R0+1
	MOVF       R8+2, 0
	MOVWF      R0+2
	MOVF       R8+3, 0
	MOVWF      R0+3
;Voltmeter.c,47 :: 		PORTD = 8;            // on  ones  ch4,  off  ch1, ch2 and ch4.
	MOVLW      8
	MOVWF      PORTD+0
;Voltmeter.c,48 :: 		PORTB = display[ch4] ;
	MOVF       R0+0, 0
	ADDLW      _display+0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      PORTB+0
;Voltmeter.c,49 :: 		delay_ms(2);
	MOVLW      3
	MOVWF      R12+0
	MOVLW      151
	MOVWF      R13+0
L_printf6:
	DECFSZ     R13+0, 1
	GOTO       L_printf6
	DECFSZ     R12+0, 1
	GOTO       L_printf6
	NOP
	NOP
;Voltmeter.c,33 :: 		for (i=0; i<=86; i++) { // routine to stabilize the changes of voltage
	INCF       printf_i_L0+0, 1
;Voltmeter.c,50 :: 		}
	GOTO       L_printf0
L_printf1:
;Voltmeter.c,51 :: 		}
L_end_printf:
	RETURN
; end of _printf

_Greeting:

;Voltmeter.c,52 :: 		void Greeting() {
;Voltmeter.c,54 :: 		short int i=0;
	CLRF       Greeting_i_L0+0
;Voltmeter.c,55 :: 		for(i=0; i<=100; i++){  //routine to see message
	CLRF       Greeting_i_L0+0
L_Greeting7:
	MOVLW      128
	XORLW      100
	MOVWF      R0+0
	MOVLW      128
	XORWF      Greeting_i_L0+0, 0
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 0
	GOTO       L_Greeting8
;Voltmeter.c,56 :: 		PORTD = 1;
	MOVLW      1
	MOVWF      PORTD+0
;Voltmeter.c,57 :: 		PORTB = 0x76 ;  //H
	MOVLW      118
	MOVWF      PORTB+0
;Voltmeter.c,58 :: 		delay_ms(2);
	MOVLW      3
	MOVWF      R12+0
	MOVLW      151
	MOVWF      R13+0
L_Greeting10:
	DECFSZ     R13+0, 1
	GOTO       L_Greeting10
	DECFSZ     R12+0, 1
	GOTO       L_Greeting10
	NOP
	NOP
;Voltmeter.c,59 :: 		PORTD = 2;
	MOVLW      2
	MOVWF      PORTD+0
;Voltmeter.c,60 :: 		PORTB = 0x79 ;  //E
	MOVLW      121
	MOVWF      PORTB+0
;Voltmeter.c,61 :: 		delay_ms(2);
	MOVLW      3
	MOVWF      R12+0
	MOVLW      151
	MOVWF      R13+0
L_Greeting11:
	DECFSZ     R13+0, 1
	GOTO       L_Greeting11
	DECFSZ     R12+0, 1
	GOTO       L_Greeting11
	NOP
	NOP
;Voltmeter.c,62 :: 		PORTD = 4;
	MOVLW      4
	MOVWF      PORTD+0
;Voltmeter.c,63 :: 		PORTB = 0x36;   //ll
	MOVLW      54
	MOVWF      PORTB+0
;Voltmeter.c,64 :: 		delay_ms(2);
	MOVLW      3
	MOVWF      R12+0
	MOVLW      151
	MOVWF      R13+0
L_Greeting12:
	DECFSZ     R13+0, 1
	GOTO       L_Greeting12
	DECFSZ     R12+0, 1
	GOTO       L_Greeting12
	NOP
	NOP
;Voltmeter.c,65 :: 		PORTD = 8;
	MOVLW      8
	MOVWF      PORTD+0
;Voltmeter.c,66 :: 		PORTB = 0x3F;   //0
	MOVLW      63
	MOVWF      PORTB+0
;Voltmeter.c,67 :: 		delay_ms(2);
	MOVLW      3
	MOVWF      R12+0
	MOVLW      151
	MOVWF      R13+0
L_Greeting13:
	DECFSZ     R13+0, 1
	GOTO       L_Greeting13
	DECFSZ     R12+0, 1
	GOTO       L_Greeting13
	NOP
	NOP
;Voltmeter.c,55 :: 		for(i=0; i<=100; i++){  //routine to see message
	INCF       Greeting_i_L0+0, 1
;Voltmeter.c,68 :: 		}
	GOTO       L_Greeting7
L_Greeting8:
;Voltmeter.c,69 :: 		PORTD = 0;    // clear PORTB and PORTD.
	CLRF       PORTD+0
;Voltmeter.c,70 :: 		PORTB = 0;
	CLRF       PORTB+0
;Voltmeter.c,71 :: 		}
L_end_Greeting:
	RETURN
; end of _Greeting

_main:

;Voltmeter.c,72 :: 		void main() {
;Voltmeter.c,73 :: 		set_up();
	CALL       _set_up+0
;Voltmeter.c,74 :: 		Greeting();
	CALL       _Greeting+0
;Voltmeter.c,75 :: 		while (1) {
L_main14:
;Voltmeter.c,76 :: 		adc_rd = ADC_Read(2);  // A/D conversion. Pin RA2 is an input.
	MOVLW      2
	MOVWF      FARG_ADC_Read_channel+0
	CALL       _ADC_Read+0
	MOVF       R0+0, 0
	MOVWF      _adc_rd+0
	MOVF       R0+1, 0
	MOVWF      _adc_rd+1
;Voltmeter.c,77 :: 		delay_ms(1);
	MOVLW      2
	MOVWF      R12+0
	MOVLW      75
	MOVWF      R13+0
L_main16:
	DECFSZ     R13+0, 1
	GOTO       L_main16
	DECFSZ     R12+0, 1
	GOTO       L_main16
;Voltmeter.c,78 :: 		tlong = (long)adc_rd * 5000;  // Convert the result in millivolts.
	MOVF       _adc_rd+0, 0
	MOVWF      R0+0
	MOVF       _adc_rd+1, 0
	MOVWF      R0+1
	CLRF       R0+2
	CLRF       R0+3
	MOVLW      136
	MOVWF      R4+0
	MOVLW      19
	MOVWF      R4+1
	CLRF       R4+2
	CLRF       R4+3
	CALL       _Mul_32x32_U+0
	MOVF       R0+0, 0
	MOVWF      _tlong+0
	MOVF       R0+1, 0
	MOVWF      _tlong+1
	MOVF       R0+2, 0
	MOVWF      _tlong+2
	MOVF       R0+3, 0
	MOVWF      _tlong+3
;Voltmeter.c,79 :: 		tlong = tlong / 1023;   // 0..1023
	MOVLW      255
	MOVWF      R4+0
	MOVLW      3
	MOVWF      R4+1
	CLRF       R4+2
	CLRF       R4+3
	CALL       _Div_32x32_S+0
	MOVF       R0+0, 0
	MOVWF      _tlong+0
	MOVF       R0+1, 0
	MOVWF      _tlong+1
	MOVF       R0+2, 0
	MOVWF      _tlong+2
	MOVF       R0+3, 0
	MOVWF      _tlong+3
;Voltmeter.c,80 :: 		printf();
	CALL       _printf+0
;Voltmeter.c,81 :: 		}
	GOTO       L_main14
;Voltmeter.c,82 :: 		} //END.
L_end_main:
	GOTO       $+0
; end of _main
